#include <pc.h>
#include <dos.h>
#include "chemix.h"
#include "chemixkb.h"
#include <stdio.h>
#include <stdlib.h>

#define SpriteWidth 32
#define SpriteHeight 32

/*typedef byte sprite_type[SpriteWidth][SpriteHeight];*/

typedef byte sprite_type[SpriteWidth*SpriteHeight];

sprite_type sprite;
scrntype scrn;
int i,j;
int sx,sy;
int LeftClip,RightClip,TopClip,BottomClip;
char ch;
paltype palette;

void InitGraphics()
{
 int k,l;
 byte i,j;
  __djgpp_nearptr_enable();
  initmg();
  Setmode(0x13);
  scrn=(scrntype)malloc(64000);
  kb_init();
  sx=160;
  sy=100;
  LeftClip=0;
  RightClip=319;
  TopClip=0;
  BottomClip=199;
  loadPCX("sprite.pcx",palette,scrn);
  setpal(palette);
  for(k=0;k<SpriteWidth;k++)
   for(l=0;l<SpriteHeight;l++)
     sprite[l*32+k]=scrn[l*320+k];

}

void ShutGraphics()
{

}


void ClipAndDrawSprite(int x,int y,scrntype scrn)
{
int i,j;
int tw,th; /* new sprite width, height */
int gx,gy; /* Where to start drawing the sprite */

if (x<RightClip && x>(LeftClip-SpriteWidth)
&& y<BottomClip && y>(TopClip-SpriteHeight)) {
tw=SpriteWidth;
th=SpriteHeight;
gx=1;
gy=1;

if (x < LeftClip)               /* Clip left side of sprite */
     gx += LeftClip-x;

if ((x + SpriteWidth)>RightClip) /* Clip right side of sprite */
   tw -= (x + SpriteWidth) - RightClip;

if (y <  TopClip)               /* Clip Top of sprite */
   gy += TopClip-y;

if ((y + SpriteHeight)>BottomClip)  /* Clip Bottom of sprite */
   th -= (y + SpriteHeight) - BottomClip;

for (i=gx;i<tw;i++)
 for (j=gy;j<th;j++)
   scrn[((j+y)*320)+(i+x)]=sprite[(j*32)+i];    /* Draw it! */
}
}

void DrawClippingBorders()
{
 line(LeftClip,TopClip,RightClip,TopClip,15,scrn);
 line(LeftClip,TopClip,LeftClip,BottomClip,14,scrn);
 line(RightClip,TopClip,RightClip,BottomClip,14,scrn);
 line(LeftClip,BottomClip,RightClip,BottomClip,15,scrn);
}



void main()
{
 InitGraphics();
 while (!(keystate(Esc)==pressed)) {
 if(keystate(Left)==held)
  sx--;
 if(keystate(Right)==held)
  sx++;
 if(keystate(Up)==held)
  sy--;
 if(keystate(Down)==held)
  sy++;
 if(keystate(_I)==held)
  BottomClip--;
 if(keystate(_J)==held)
  RightClip--;
 if(keystate(_K)==held)
  TopClip++;
 if(keystate(_L)==held)
  LeftClip++;
 ClipAndDrawSprite(sx,sy,scrn);
 DrawClippingBorders();
 flip(scrn,screen);
 cls(scrn,0);
 waitretrace();
}
ShutGraphics;
  Setmode(0x3);
  free(scrn);
  kb_exit();
  __djgpp_nearptr_disable();
  printf("Chemix -1998 : GeneralZoftware@pemail.com ");
}


